/*
 * @Author: Kane
 * @Date: 2023-05-02 10:11:27
 * @LastEditors: Kane
 * @FilePath: /desktop_archievement_backend/src/main/java/com/cpic/xim/utils/archievement/DepartmentArchievement.java
 * @Description: 
 * 
 * Copyright (c) ${2022} by Kane, All Rights Reserved. 
 */
package com.cpic.xim.utils.archievement;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.CallableStatement;

import java.util.Vector;
import com.fasterxml.jackson.annotation.JsonProperty;

public class DepartmentArchievement
{

    // 以后要改
    private static String jdbcURL = "jdbc:oracle:thin:@10.39.0.86:1521:xmcx1";
    private static String userName = "desktop_archievement_admin";
    private static String password = "Cpic123456";

    /**
     * 默认的构造函数，提供给json使用。
     */
    public DepartmentArchievement()
    {
        this.totalArchievement = 0;
        this.mensualArchievementList = new Vector<>();
        this.insuranceRenewalRate = "";
        this.attachingRate = "";
    }

    /**
     * @brief 构造函数，提供所有成员对象的值。
     * @param totalArchievement
     * @param mensualArchievementList
     * @param insuranceRenewalRate
     * @param attachingRate
     */
    public DepartmentArchievement( int totalArchievement, Vector<Integer> mensualArchievementList,
            String insuranceRenewalRate, String attachingRate)
    {
        this.totalArchievement = totalArchievement;
        this.mensualArchievementList = mensualArchievementList;
        this.insuranceRenewalRate = insuranceRenewalRate;
        this.attachingRate = attachingRate;
    }

    /**
     * 静态方法，用于根据部门代码，查询部门业绩，生成一个 DepartmentArchievement 对象。
     * @param departmentCode 部门代码
     * @return
     * @throws SQLException
     * @throws ClassNotFoundException
     */
    public static DepartmentArchievement queryDepartmentArchievement( String departmentCode )
            throws SQLException, ClassNotFoundException
    {
        DepartmentArchievement archievement = new DepartmentArchievement();

        String sql = "{call telsale_archievement_pkg.department_archievement(?,?,?)}";

        Class.forName( "oracle.jdbc.driver.OracleDriver" );
        Connection connection = DriverManager.getConnection( jdbcURL, userName, password );
        java.sql.CallableStatement statement = connection.prepareCall( sql );

        statement.setString( 1, departmentCode );
        statement.registerOutParameter( 2, java.sql.Types.VARCHAR );
        statement.registerOutParameter( 3, java.sql.Types.VARCHAR );

        statement.execute();

        String attach_rate = statement.getString( 2 );
        String renewal_rate = statement.getString( 3 );

        archievement.setAttachingRate( attach_rate );
        archievement.setInsuranceRenewalRate( renewal_rate );

        return archievement;
    }

    public int getTotalArchievement()
    {
        return totalArchievement;
    }

    public void setTotalArchievement( int totalArchievement )
    {
        this.totalArchievement = totalArchievement;
    }

    public Vector<Integer> getMensualArchievementList()
    {
        return mensualArchievementList;
    }

    public void setMensualArchievementList( Vector<Integer> mensualArchievementList )
    {
        this.mensualArchievementList = mensualArchievementList;
    }

    public String getInsuranceRenewalRate()
    {
        return insuranceRenewalRate;
    }

    public void setInsuranceRenewalRate( String insuranceRenewalRate )
    {
        this.insuranceRenewalRate = insuranceRenewalRate;
    }

    public String getAttachingRate()
    {
        return attachingRate;
    }

    public void setAttachingRate( String attachingRate )
    {
        this.attachingRate = attachingRate;
    }

    @JsonProperty( "total_archievement" )
    private int totalArchievement; // 总业绩

    // 每月业绩列表
    // 要保证数据是按照月份排序。
    @JsonProperty( "mensual_archievement_list" )
    private Vector<Integer> mensualArchievementList;

    @JsonProperty( "insurance_renewal_rate" )
    private String insuranceRenewalRate; // 续保率

    @JsonProperty( "attaching_rate" )
    private String attachingRate; // 车非渗透率
}
